#pragma once

class Delay
{	
private:
	double* delayline;
	int size;
	int writepos;
	int dly;

public:
	double out_v;
	Delay::Delay(int length)
	{
		this->dly = length;
		size = dly+1;
		delayline = new double[size];		
		reset();		
	}

	Delay::~Delay()
	{
		delete[] delayline;
	}

	void Delay::reset()
	{
		writepos = -1;
		for(int i=0; i<size;i++) delayline[i]=0.0;
	}

	void Delay::SetDelay(int dly)
	{
		this->dly = max(0,min(dly, size-1));
	}

	double Delay::process(double v)
	{
		writepos++;
		if(writepos==size) writepos=0;
		delayline[writepos] = v;

		int readpos = writepos - dly;
		if(readpos<0) readpos += size;
		out_v = delayline[readpos];
		return out_v;
	}

	double Delay::operator[](int index)
	{	
		if(index<0) index = - index;
		return delayline[(size + writepos - index) % size];
	}
};